<?php

/**
 * Implmentation of hook_views_data().
 */
function update_status_aggregator_server_views_data() {
  $data = array();

  $data['usa_projects'] = array(
    'table' => array(
      'group' => t('Projects'),
      'base' => array(
        'field' => 'pid',
        'title' => t('Update status - projects'),
        'help' => t('Shows information about the projects that this server tracks.'),
      ),
    ),

    'pid' => array(
      'title' => t('ID'),
      'help' => t('The internal package ID.'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_numeric',
      ),
    ),

    'name' => array(
      'title' => t('Package'),
      'help' => t('The internal package name.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'project_type' => array(
      'title' => t('Project type'),
      'help' => t('The type of project.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_in_operator',
        'options callback' => 'update_status_aggregator_server_project_types',
      ),
    ),

    'existing_version' => array(
      'title' => t('Existing version'),
      'help' => t('The version of the project installed.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'datestamp' => array(
      'title' => t('Project updated date'),
      'help' => t('When the project was last updated.'),
      'field' => array(
        'handler' => 'views_handler_field_date',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_date',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort_date',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_date',
      ),
    ),

    'install_type' => array(
      'title' => t('Install type'),
      'help' => t('Either offical, or dev, or unknown.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'latest_version' => array(
      'title' => t('Latest version'),
      'help' => t('The latest version of the project available.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'recommended' => array(
      'title' => t('Recommended version'),
      'help' => t('The recommened version of the project for you.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'status' => array(
      'title' => t('Status'),
      'help' => t('The status of the project.'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_in_operator',
        'options callback' => 'update_status_aggregator_server_project_statuses',
      ),
    ),

    'status_image' => array(
      'title' => t('Status - Image'),
      'help' => t('The status of the project.'),
      'field' => array(
        'real field' => 'status',
        'handler' => 'update_status_aggregator_status_image',
        'click sortable' => TRUE,
      ),
    ),

    'status_text' => array(
      'title' => t('Status - Text'),
      'help' => t('The status of the project.'),
      'field' => array(
        'real field' => 'status',
        'handler' => 'update_status_aggregator_status_text',
        'click sortable' => TRUE,
      ),
    ),

    'title' => array(
      'title' => t('Title'),
      'help' => t('The name of the Package, if we have one.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),
  );

  $data['usa_sites'] = array(
    'table' => array(
      'group' => t('Sites'),
      'join' => array(
        'usa_projects' => array(
          'field' => 'sid',
          'left_field' => 'sid',
        ),
      ),
    ),

    'sid' => array(
      'title' => t('Site ID'),
      'help' => t('The internal ID of the site.'),
      'field' => array(
        'handler' => 'views_handler_field_numeric',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_numeric',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'title' => t('Site name - Options'),
        'handler' => 'views_handler_filter_in_operator',
        'options callback' => 'update_status_aggregator_server_site_get_all_as_options',
      ),
    ),



    'site_url' => array(
      'title' => t('Site URL'),
      'help' => t('The URL of the site.'),
      'field' => array(
        'handler' => 'views_handler_field_url',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

    'site_name' => array(
      'title' => t('Site name'),
      'help' => t('The name of the site.'),
      'field' => array(
        'handler' => 'views_handler_field',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'title' => t('Site name'),
        'handler' => 'views_handler_filter_string',
      ),

    ),

    'site_email' => array(
      'title' => t('Site Email'),
      'help' => t('The URL of the site.'),
      'field' => array(
        'handler' => 'views_handler_field_string',
        'click sortable' => TRUE,
      ),
      'argument' => array(
        'handler' => 'views_handler_argument_string',
      ),
      'sort' => array(
        'handler' => 'views_handler_sort',
      ),
      'filter' => array(
        'handler' => 'views_handler_filter_string',
      ),
    ),

  );

  return $data;
}

/**
 * Implementation of hook_views_handlers()
 *
 * Register all our custom handlers with views.
 */
function update_status_aggregator_server_views_handlers() {
  return array(
    'info' => array(
      'path' => drupal_get_path('module', 'update_status_aggregator_server') . '/views/handlers',
    ),
    'handlers' => array(
      'update_status_aggregator_status_image' => array(
        'parent' => 'views_handler_field',
      ),
      'update_status_aggregator_status_text' => array(
        'parent' => 'views_handler_field',
      ),
    ),
  );
}
