<?php

class update_status_aggregator_status_image extends views_handler_field {

  /**
   * Render as human readable name.
   */
  function render_name($data, $values) {
    if ($data !== NULL && $data !== '') {
      drupal_load('module', 'update');
      switch ($data) {
        case UPDATE_CURRENT:
          $class = 'ok';
          $icon = theme('image', 'misc/watchdog-ok.png', t('ok'), t('ok'));
          break;
        case UPDATE_UNKNOWN:
        case UPDATE_NOT_FETCHED:
          $class = 'unknown';
          $icon = theme('image', 'misc/watchdog-warning.png', t('warning'), t('warning'));
          break;
        case UPDATE_NOT_SECURE:
        case UPDATE_REVOKED:
        case UPDATE_NOT_SUPPORTED:
          $class = 'error';
          $icon = theme('image', 'misc/watchdog-error.png', t('error'), t('error'));
          break;
        case UPDATE_NOT_CHECKED:
        case UPDATE_NOT_CURRENT:
        default:
          $class = 'warning';
          $icon = theme('image', 'misc/watchdog-warning.png', t('warning'), t('warning'));
          break;
      }
      return $icon;
    }
    else {
      return check_plain($data);
    }
  }

  function render($values) {
    return $this->render_name($values->{$this->field_alias}, $values);
  }
}